﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Threading.Tasks;
using FinecarRentCar.DAL;
using Microsoft.AspNetCore.Mvc;

namespace FinecarRentCar.Controllers.Statistic
{
    public partial class StatisticController : Controller
    {
        private ICarRepository _carRepository = new CarRepository(new Data.FinecarDbContext());
        private Data.FinecarDbContext db = new Data.FinecarDbContext();
        public IActionResult AllStatistics()
        {
            return View();
        }
        [Route("administrace/vozovy-park-prehled")]
        public IActionResult AllCarStatistics()
        {
            using(var conn = new SqlConnection("Data Source=den1.mssql4.gear.host;Initial Catalog=syncfusiontestdb;User Id=syncfusiontestdb;Password=Hj85-E1Sq-zC"))
            {
                conn.Open();
                var query = "SELECT Categories.CategoryName, COUNT(dbo.CarCategories.CarID) as CarCount FROM dbo.CarCategories INNER JOIN dbo.Categories ON CarCategories.CategoryID = Categories.ID GROUP BY Categories.CategoryName";
                var cmd = new SqlCommand(query, conn);
                using(var reader = cmd.ExecuteReader())
                {
                    var category = new Helpers.GenericPopulator().CreateList(reader);

                    ViewBag.dataSource = category;

                    reader.Close();
                }
                conn.Close();
            }
            return View();
        }

        public JsonResult GetChartData()
        {
            List<CategoryCar> dataSource;
            using (var conn = new SqlConnection(Helpers.ConnClass.ConnectString()))
            {
                conn.Open();
                var query = "SELECT Categories.CategoryName, COUNT(dbo.CarCategories.CarID) as CarCount FROM dbo.CarCategories INNER JOIN dbo.Categories ON CarCategories.CategoryID = Categories.ID GROUP BY Categories.CategoryName";
                var cmd = new SqlCommand(query, conn);
                using (var reader = cmd.ExecuteReader())
                {
                    var category = new Helpers.GenericPopulator().CreateList(reader);

                    dataSource = category;

                    reader.Close();
                }
                conn.Close();
            }
            return Json(dataSource);
        }
        [Serializable]
        public class CategoryCar
        {
            public string CatName;
            public double CarCount;
        }

    }
}